
<template>
  <div class="app-wrapper">
    <LoginModal v-if="login_modal_open" @close-modal="login_modal_open = false"></LoginModal>
    <MetaboservNavbar @login-clicked="toggleLoginModal"></MetaboservNavbar>
    <RouterView style="margin-top: 5rem;"></RouterView>
    <MessageBox></MessageBox>

  </div>
  <MetaboservFooter></MetaboservFooter>
</template>

<script setup lang="ts">
import { RouterView, useRouter } from 'vue-router';
import LoginModal from './components/auth/LoginModal.vue';
import MetaboservNavbar from './components/MetaboservNavbar.vue';
import MetaboservFooter from './components/MetaboservFooter.vue';
import { ref } from 'vue';
import { useAuthStore } from './stores/auth';
import { logout } from './modules/auth_module';
import { useStudyStore } from './stores/studies';
import { getStudyList } from './modules/study_module';
import MessageBox from "./components/misc/MessageBox.vue";
import { useMessageStore } from "./stores/message";



const auth = useAuthStore();
const studies = useStudyStore();
const router = useRouter();
const msg = useMessageStore();

const toggleLoginModal = async () => {
  if (auth.jwt || auth.aut) {
    logout();
    msg.add_message({status: 200, msg: "Logged out successfully."});
    studies.clearStudies();
    router.push('/');
    await getStudyList();
  }
  else {
    login_modal_open.value = !login_modal_open.value;
  }
}

const login_modal_open = ref(false);
</script>


<style>

* {
  margin: 0;
}

body {
  line-height: 1.5;
  -webkit-font-smoothing: antialiased;
}

img, picture, video, canvas, svg {
  display: block;
  max-width: 100%;
}

input, button, textarea, select {
  font: inherit;
}

p, h1, h2, h3, h4, h5, h6 {
  overflow-wrap: break-word;
}

#root, #__next {
  isolation: isolate;
}

:root {

  --color-blood: #db9494;
  --color-urine: #cfce92;
  --color-feces: #a37c7c;
  --color-csf: #e277cb;
  --color-unknown: #c3c3c3;
  --color-other: #8bd698;

  --color-head: #116580;
  --color-primary: #318ead;
  --color-secondary: #9accdc;
  --color-accent: #70bcd6;
  --color-text: #0e171a;
  --color-bg: #f6f9fa;
  --color-bg-alt: #efeff0;
  --color-shadow: rgba(0, 0, 0, 0.2);
  --color-info: #7a7a7a;
  --color-positive: #1c9204;
  --color-negative: #9e0505;

  --fs-small: 0.875rem;
  --fs-default: 1.125rem;
  --fs-large: 1.25rem;
  --fs-title: 1.5rem;
  --ff-default: MuseoSansLight, sans-serif;
  --ff-code: 'Roboto Mono', monospace;

  --bd-default: solid var(--color-head) 1px;
  --sd-default: 2px 4px 30px var(--color-shadow);
  --sd-larger: 5px 10px 10px var(--color-shadow);
}

a , a:hover, a:active {
  color: var(--color-bg);
  text-decoration: none;
  background-color: inherit;
  transition: none;
}

body, html {
  font-family: var(--ff-default);
  color: var(--color-text);
  background-color: var(--color-bg);
  font-size: var(--fs-default);
}

#app {
  max-width: 100%;
  margin: auto;
}

input[type="text"], input[type="password"], input[type="checkbox"] {
  accent-color: var(--color-accent);
}

.internal-link {
  color: var(--color-primary);
  cursor: pointer;
}

.internal-link:hover {
  color: var(--color-head);
}

.modal-background {
  width: 100%;
  min-height: 100%;
  position: fixed;
  inset: 0 0;
  z-index: 30;
  background-color: rgba(239,239,240, 0.7);
  display: flex;
  align-items: center;
  justify-items: center;
  flex-direction: column;
  overflow-y: auto;
}

.buttons {
    display: flex;
    align-content: center;
    justify-content: center;
    margin: auto;
    gap: 1rem;
    align-items: center;
}

.rule-grid {
  display: grid;
  max-width: 100%;
  grid-template-columns: 1fr 1fr 1fr 48px;
  grid-auto-flow: row;
  column-gap: 8px;
  border: solid 2px var(--color-unknown);
  padding: 0.5rem;
  overflow-x: hidden;
  overflow-y: auto;
}

.rule-grid-add {
  grid-column: 1 / 7;
  color: var(--color-head);
  font-size: var(--fs-title);
  text-align: center;
  cursor: pointer;
}

.rule-item {
  display: grid;
  grid-column: 1 / 6;
  grid-template-columns: subgrid;
}

.rule-grid-add:hover {
  scale: 1.1 1.1;
}


</style>

<style scoped>

.app-wrapper {
  min-height: calc(100vh - 50px);
}

</style>